<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__hal__adc" kind="group">
    <compoundname>group_hal_adc</compoundname>
    <title>ADC (Analog to Digital Converter)</title>
    <innerclass prot="public" refid="structcyhal__adc__config__t">cyhal_adc_config_t</innerclass>
    <innerclass prot="public" refid="structcyhal__adc__channel__config__t">cyhal_adc_channel_config_t</innerclass>
    <innergroup refid="group__group__hal__results__adc">ADC HAL Results</innergroup>
      <sectiondef kind="enum">
      <memberdef id="group__group__hal__adc_1gad77d58d52432f1f68f869b047b1a9bbe" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_adc_vref_t</name>
        <enumvalue id="group__group__hal__adc_1ggad77d58d52432f1f68f869b047b1a9bbeac3e8e93e60d21bfe83545ac9e4f8ca15" prot="public">
          <name>CYHAL_ADC_REF_INTERNAL</name>
          <briefdescription>
<para>Internal reference. See the BSP documentation for the value of this reference. (Default) </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__adc_1ggad77d58d52432f1f68f869b047b1a9bbea78d9a5640a2866dad2f5e87d356a6c74" prot="public">
          <name>CYHAL_ADC_REF_EXTERNAL</name>
          <briefdescription>
<para>Reference from external pin. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__adc_1ggad77d58d52432f1f68f869b047b1a9bbea56163f5889cb958d81515c6e751e480e" prot="public">
          <name>CYHAL_ADC_REF_VDDA</name>
          <briefdescription>
<para>Reference from VDDA (analog supply) </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__adc_1ggad77d58d52432f1f68f869b047b1a9bbea113f7ecc2ff424688320cfb62ce1c79e" prot="public">
          <name>CYHAL_ADC_REF_VDDA_DIV_2</name>
          <briefdescription>
<para>Reference from VDDA (analog supply) divided by 2. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_adc_vref_t: </bold><linebreak />Possible selections for ADC reference.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="126" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="120" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="121" />
      </memberdef>
      <memberdef id="group__group__hal__adc_1gac9e066ac01bed2c374c3d0e164988d97" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_adc_vneg_t</name>
        <enumvalue id="group__group__hal__adc_1ggac9e066ac01bed2c374c3d0e164988d97a10b9c188fccf67e20b0fce8d6fef6bc0" prot="public">
          <name>CYHAL_ADC_VNEG_VSSA</name>
          <briefdescription>
<para>Connect vminus to ground. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__adc_1ggac9e066ac01bed2c374c3d0e164988d97a2c7f27a19dbe55e6ddd9997b07439ce1" prot="public">
          <name>CYHAL_ADC_VNEG_VREF</name>
          <briefdescription>
<para>Connect vminus to the selected vref (see <ref kindref="member" refid="group__group__hal__adc_1gad77d58d52432f1f68f869b047b1a9bbe">cyhal_adc_vref_t</ref>) </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_adc_vneg_t: </bold><linebreak />Vminus selection for single-ended channels.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="133" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="129" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="130" />
      </memberdef>
      <memberdef id="group__group__hal__adc_1ga3e21dc2fe98693d72260411459e1fc6c" kind="enum" prot="public" static="no" strong="no">
        <type />
        <name>cyhal_adc_event_t</name>
        <enumvalue id="group__group__hal__adc_1gga3e21dc2fe98693d72260411459e1fc6ca72cdd442365c9b501eb0144ef31beb83" prot="public">
          <name>CYHAL_ADC_EOS</name>
          <initializer>= 1u</initializer>
          <briefdescription>
<para>End of scan: a scan of all channels has completed. Only applicable when continuously scanning. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <enumvalue id="group__group__hal__adc_1gga3e21dc2fe98693d72260411459e1fc6ca4a42dd67489a8b89bb8b1fefdac6c86c" prot="public">
          <name>CYHAL_ADC_ASYNC_READ_COMPLETE</name>
          <initializer>= 2u</initializer>
          <briefdescription>
<para>An asynchronous read operation has completed. </para>          </briefdescription>
          <detaileddescription>
          </detaileddescription>
        </enumvalue>
        <briefdescription>
<para><bold>cyhal_adc_event_t: </bold><linebreak />ADC events.</para></briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="140" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="136" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="137" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="typedef">
      <memberdef id="group__group__hal__adc_1gae4fceb1fa1f96b3212106fda6b113836" kind="typedef" prot="public" static="no">
        <type>void(*</type>
        <definition>typedef void(* cyhal_adc_event_callback_t) (void *callback_arg, cyhal_adc_event_t event)</definition>
        <argsstring>)(void *callback_arg, cyhal_adc_event_t event)</argsstring>
        <name>cyhal_adc_event_callback_t</name>
        <briefdescription>
<para>Handler for ADC event callbacks. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="221" column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="221" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="func">
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga7618b26a0677cb3f8cd477e3731da510" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_adc_init</definition>
        <argsstring>(cyhal_adc_t *obj, cyhal_gpio_t pin, const cyhal_clock_t *clk)</argsstring>
        <name>cyhal_adc_init</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>pin</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__clock__t">cyhal_clock_t</ref> *</type>
          <declname>clk</declname>
        </param>
        <briefdescription>
<para>Initialize ADC peripheral. </para>        </briefdescription>
        <detaileddescription>
<para>The ADC will be initialized with the following default configuration:<itemizedlist>
<listitem><para>Sample rate: See implementation-specific documentation</para></listitem><listitem><para>Average count: 1 (averaging disabled).</para></listitem><listitem><para>Continuous scanning: false</para></listitem><listitem><para>Single ended vneg: <ref kindref="member" refid="group__group__hal__adc_1ggac9e066ac01bed2c374c3d0e164988d97a2c7f27a19dbe55e6ddd9997b07439ce1">CYHAL_ADC_VNEG_VREF</ref></para></listitem><listitem><para>Vref: <ref kindref="member" refid="group__group__hal__adc_1ggad77d58d52432f1f68f869b047b1a9bbeac3e8e93e60d21bfe83545ac9e4f8ca15">CYHAL_ADC_REF_INTERNAL</ref></para></listitem><listitem><para>External vref: <ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__04__80__tqfp_1gga43c4aa9a5556b7386cb604f0ab3b242ca3dbd1016ea99d087d747530418b89a01">NC</ref></para></listitem><listitem><para>Bypassed: false</para></listitem><listitem><para>Bypass pin: <ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__04__80__tqfp_1gga43c4aa9a5556b7386cb604f0ab3b242ca3dbd1016ea99d087d747530418b89a01">NC</ref></para></listitem><listitem><para>Power level: <ref kindref="member" refid="group__group__hal__general__types_1gga246fde0e79029f514ce3846b31e366d7a6f0f4df45e9cac012a2c8e5ba736241b">CYHAL_POWER_LEVEL_DEFAULT</ref></para></listitem></itemizedlist>
</para><para>To change the configuration, see <ref kindref="member" refid="group__group__hal__adc_1gae1abce4e4cfe015eb4cd4dd055ca3065">cyhal_adc_configure</ref></para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>Pointer to an ADC object. The caller must allocate the memory for this object but the init function will initialize its contents. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">pin</parametername>
</parameternamelist>
<parameterdescription>
<para>A pin corresponding to the ADC block to initialize Note: This pin is not reserved, it is just used to identify which ADC block to allocate. If multiple channels will be allocated for a single ADC instance, only one pin should be passed here; it does not matter which one. After calling this function once, call <ref kindref="member" refid="group__group__hal__adc_1gaba21a0c4d83266951823ea5d9eba39b9">cyhal_adc_channel_init_diff</ref> once for each pin whose value should be measured. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">clk</parametername>
</parameternamelist>
<parameterdescription>
<para>The clock to use can be shared, if not provided a new clock will be allocated </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request. <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> is returned on success. On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver.<linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="251" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1gadae8361e3e3e3d0ff96767e1e8e1d913" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_adc_free</definition>
        <argsstring>(cyhal_adc_t *obj)</argsstring>
        <name>cyhal_adc_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Uninitialize the ADC peripheral and <ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> object. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="257" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1gae1abce4e4cfe015eb4cd4dd055ca3065" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_adc_configure</definition>
        <argsstring>(cyhal_adc_t *obj, const cyhal_adc_config_t *config)</argsstring>
        <name>cyhal_adc_configure</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__adc__config__t">cyhal_adc_config_t</ref> *</type>
          <declname>config</declname>
        </param>
        <briefdescription>
<para>Update the ADC configuration. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If a scan is in progress, this may cause it to be interrupted.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">config</parametername>
</parameternamelist>
<parameterdescription>
<para>The configuration to apply </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the configuration request On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver.<linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="270" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1gacfbd0adfbe5291b0cf131b6b07c4053b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_adc_set_power</definition>
        <argsstring>(cyhal_adc_t *obj, cyhal_power_level_t power)</argsstring>
        <name>cyhal_adc_set_power</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__general__types_1ga246fde0e79029f514ce3846b31e366d7">cyhal_power_level_t</ref></type>
          <declname>power</declname>
        </param>
        <briefdescription>
<para>Changes the current operating power level of the ADC. </para>        </briefdescription>
        <detaileddescription>
<para>If the power level is set to <ref kindref="member" refid="group__group__hal__general__types_1gga246fde0e79029f514ce3846b31e366d7a0f601c5d5843c59e58ee1988dd0e6861">CYHAL_POWER_LEVEL_OFF</ref>, the ADC will be powered-off but it will retain its configuration, so it is not necessary to reconfigure it when changing the power level from <ref kindref="member" refid="group__group__hal__general__types_1gga246fde0e79029f514ce3846b31e366d7a0f601c5d5843c59e58ee1988dd0e6861">CYHAL_POWER_LEVEL_OFF</ref> to any other value.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>ADC object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">power</parametername>
</parameternamelist>
<parameterdescription>
<para>The power level to set </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set power request On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver.<linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="285" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga15c047136b7a47d12dbafaa1e415ab59" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_adc_set_sample_rate</definition>
        <argsstring>(cyhal_adc_t *obj, uint32_t desired_sample_rate_hz, uint32_t *achieved_sample_rate_hz)</argsstring>
        <name>cyhal_adc_set_sample_rate</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>uint32_t</type>
          <declname>desired_sample_rate_hz</declname>
        </param>
        <param>
          <type>uint32_t *</type>
          <declname>achieved_sample_rate_hz</declname>
        </param>
        <briefdescription>
<para>Configure the number of samples per second. </para>        </briefdescription>
        <detaileddescription>
<para>This is the number of times each enabled channel is sampled per second. The total number of samples performed by the ADC hardware per second is equal to sample_rate_hz / num_channels_enabled. Depending on the system clock configuration or limitations of the underlying hardware, it may not be possible to achieve precisely the desired sample rate. The achived_sample_rate_hz parameter will be updated to indicate the sample rate that was achived. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The achieved_sample_rate_hz value is only valid while the configuration of the ADC and its channels remains umodified. If &lt;a href="group__group__hal__adc.html#group__group__hal__adc_1gae1abce4e4cfe015eb4cd4dd055ca3065"&gt;cyhal_adc_configure&lt;/a&gt;, &lt;a href="group__group__hal__adc.html#group__group__hal__adc_1gaba21a0c4d83266951823ea5d9eba39b9"&gt;cyhal_adc_channel_init_diff&lt;/a&gt;, &lt;a href="group__group__hal__adc.html#group__group__hal__adc_1ga504f26400e475a67e978fb1a75b67f1c"&gt;cyhal_adc_channel_configure&lt;/a&gt;, or &lt;a href="group__group__hal__adc.html#group__group__hal__adc_1ga55d144073f10cf6b6a1edcf6b9f59c78"&gt;cyhal_adc_channel_free&lt;/a&gt; is called, it is necessary to call this function again in order to update the sample rate. Therefore, it is recommended to call this function after the ADC and all channels have been configured.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC object to configure </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">desired_sample_rate_hz</parametername>
</parameternamelist>
<parameterdescription>
<para>The desired sample rate, in hertz </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="out">achieved_sample_rate_hz</parametername>
</parameternamelist>
<parameterdescription>
<para>The achieved sample rate, in hertz</para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the sample rate request. Note that inability to exactly match the requested sample rate is not considered an error. It is the application's responsibility to determine whether the achived rate is within the tolerance that it requires. <ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref> is returned on success.<linebreak />
 On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver.<linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="310" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1gaba21a0c4d83266951823ea5d9eba39b9" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_adc_channel_init_diff</definition>
        <argsstring>(cyhal_adc_channel_t *obj, cyhal_adc_t *adc, cyhal_gpio_t vplus, cyhal_gpio_t vminus, const cyhal_adc_channel_config_t *cfg)</argsstring>
        <name>cyhal_adc_channel_init_diff</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>adc</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>vplus</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1ga707195ce0627016bf371643bdd9caa51">cyhal_gpio_t</ref></type>
          <declname>vminus</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__adc__channel__config__t">cyhal_adc_channel_config_t</ref> *</type>
          <declname>cfg</declname>
        </param>
        <briefdescription>
<para>Initialize a differential ADC channel. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;: Some platforms may restrict which pins can be used as part of a differential pair. See the implementation-specific documentation for details.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Configures the pin used by ADC. </verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="out">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC channel object to initialize </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">adc</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC for which the channel should be initialized </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">vplus</parametername>
</parameternamelist>
<parameterdescription>
<para>Non-inverting input </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">vminus</parametername>
</parameternamelist>
<parameterdescription>
<para>Inverting input. For a single ended channel, use <ref kindref="member" refid="group__group__hal__adc_1ga00175bb8e85fface6d74488febb0cf27">CYHAL_ADC_VNEG</ref>. </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">cfg</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC channel configuration </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the init request. On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver.<linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="327" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga504f26400e475a67e978fb1a75b67f1c" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_adc_channel_configure</definition>
        <argsstring>(cyhal_adc_channel_t *obj, const cyhal_adc_channel_config_t *config)</argsstring>
        <name>cyhal_adc_channel_configure</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__adc__channel__config__t">cyhal_adc_channel_config_t</ref> *</type>
          <declname>config</declname>
        </param>
        <briefdescription>
<para>Update the ADC channel configuration. </para>        </briefdescription>
        <detaileddescription>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If a scan is in progress, this may cause it to be interrupted. It is not valid to change the enabled state of a channel while an asynchronous read operation is in progress.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC channel object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">config</parametername>
</parameternamelist>
<parameterdescription>
<para>The configuration to apply </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the configuration request On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver.<linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="341" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga55d144073f10cf6b6a1edcf6b9f59c78" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_adc_channel_free</definition>
        <argsstring>(cyhal_adc_channel_t *obj)</argsstring>
        <name>cyhal_adc_channel_free</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Uninitialize the ADC channel and <ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref> object. </para>        </briefdescription>
        <detaileddescription>
<para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="inout">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC channel object </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="347" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga2baef8269f13b3c7da46cdabcef650a0" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>uint16_t</type>
        <definition>uint16_t cyhal_adc_read_u16</definition>
        <argsstring>(const cyhal_adc_channel_t *obj)</argsstring>
        <name>cyhal_adc_read_u16</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Read the value from the ADC pin, represented as an unsigned 16bit value where 0x0000 represents the minimum value in the ADC's range, and 0xFFFF represents the maximum value in the ADC's range. </para>        </briefdescription>
        <detaileddescription>
<para>If continous scanning is disabled, this will block while a conversion is performed on the selected channel, then return the result. Depending on the ADC speed this function may block for some time. If continuous scanning is enabled, this will return the value from the most recent conversion of the specified channel (if called shortly after enabling continuous scanning it may block until at least one conversion has been performed on this channel).</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>An unsigned 16bit value representing the current input voltage </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="363" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga7207c3d089c48255e382cfe159a04ed0" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int32_t</type>
        <definition>int32_t cyhal_adc_read</definition>
        <argsstring>(const cyhal_adc_channel_t *obj)</argsstring>
        <name>cyhal_adc_read</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Read the value from ADC pin, represented as a 32-bit signed, right-aligned value. </para>        </briefdescription>
        <detaileddescription>
<para>This is a 'resolution'-bit value, sign-extended to 32 bits. If the vplus signal is below the vminus signal, the result will be negative. If the vplus signal is above the vminus signal, the result will be positive. If continous scanning is disabled, this will block while a conversion is performed on the selected channel, then return the result. Depending on the ADC speed this function may block for some time. If continuous scanning is enabled, this will return the value from the most recent conversion of the specified channel (if called shortly after enabling continuous scanning it may block until at least one conversion has been performed on this channel).</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>A signed 32 bit value representing the current input voltage </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="381" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga515d09fb9917bee89b3147852d0a3659" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>int32_t</type>
        <definition>int32_t cyhal_adc_read_uv</definition>
        <argsstring>(const cyhal_adc_channel_t *obj)</argsstring>
        <name>cyhal_adc_read_uv</name>
        <param>
          <type>const <ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <briefdescription>
<para>Read the value from ADC pin, in microvolts. </para>        </briefdescription>
        <detaileddescription>
<para>If continous scanning is disabled, this will block while a conversion is performed on the selected channel, then return the result. Depending on the ADC speed this function may block for some time. If continuous scanning is enabled, this will return the value from the most recent conversion of the specified channel (if called shortly after enabling continuous scanning it may block until at least one conversion has been performed on this channel).</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC object </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>An unsigned 32 bit value representing the current input in microvolts </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="396" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga7386fc156403ea08380c4410665b4ae2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_adc_read_async</definition>
        <argsstring>(cyhal_adc_t *obj, size_t num_scan, int32_t *result_list)</argsstring>
        <name>cyhal_adc_read_async</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>num_scan</declname>
        </param>
        <param>
          <type>int32_t *</type>
          <declname>result_list</declname>
        </param>
        <briefdescription>
<para>Scan the specified ADC channels in the background and copy the results into the array pointed to by result_list. </para>        </briefdescription>
        <detaileddescription>
<para>Results are represented as 32-bit signed, right-aligned values. That is, they are 'resolution'-bit values, sign-extended to 32 bits. If the vplus signal is below the vminus signal, the result will be negative. If the vplus signal is above the vminus signal, the result will be positive.</para><para>If continuous scanning is disabled, this will trigger num_scan new scans and copy the results into result_list once the scan is completed.</para><para>If continuous scanning is enabled, this will copy the results of num_scan scans into the result_list as they complete, beginning with the most recently completed scan (if one exists).</para><para>Scan results are placed sequentially into result_list. That is, result_list will contain all of the results from the first scan, followed by all of the results from the second scan, etc. If channels exist that are initialized but not enabled, they will consume locations in result_list, but these values are undefined.</para><para>When the requested number of scans have been completed, the <ref kindref="member" refid="group__group__hal__adc_1gga3e21dc2fe98693d72260411459e1fc6ca4a42dd67489a8b89bb8b1fefdac6c86c">CYHAL_ADC_ASYNC_READ_COMPLETE</ref> event will be raised.</para><para><ref kindref="member" refid="group__group__hal__adc_1gac00f1d333ef4023e3d41dad9dbee5413">cyhal_adc_set_async_mode</ref> can be used to control whether this uses DMA or a SW (CPU-driven) transfer.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>ADC to read from </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">num_scan</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of scans of each channel that should be read </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">result_list</parametername>
</parameternamelist>
<parameterdescription>
<para>The array where results should be. This must be of length num_scan * initialized_channels, where initialized_channels is the number of channels that have been initialized for this ADC (and not later freed) via <ref kindref="member" refid="group__group__hal__adc_1gaba21a0c4d83266951823ea5d9eba39b9">cyhal_adc_channel_init_diff</ref> </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read async request On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver.<linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="430" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga4bdd118986c58fdfe4d832123fb8a31d" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_adc_read_async_uv</definition>
        <argsstring>(cyhal_adc_t *obj, size_t num_scan, int32_t *result_list)</argsstring>
        <name>cyhal_adc_read_async_uv</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type>size_t</type>
          <declname>num_scan</declname>
        </param>
        <param>
          <type>int32_t *</type>
          <declname>result_list</declname>
        </param>
        <briefdescription>
<para>Scan the specified ADC channels in the background and copy the conversion results in microvolts into the array pointed to by result_list. </para>        </briefdescription>
        <detaileddescription>
<para>If continuous scanning is disabled, this will trigger num_scan new scans and copy the results into result_list once the scan is completed.</para><para>If continuous scanning is enabled, this will copy the results of num_scan scans into the result_list as they complete, beginning with the most recently completed scan (if one exists).</para><para>Scan results are placed sequentially into result_list. That is, result_list will contain all of the results from the first scan, followed by all of the results from the second scan, etc. If channels exist that are initialized but not enabled, they will consume locations in result_list, but these values are undefined.</para><para>When the requested number of scans have been completed, the <ref kindref="member" refid="group__group__hal__adc_1gga3e21dc2fe98693d72260411459e1fc6ca4a42dd67489a8b89bb8b1fefdac6c86c">CYHAL_ADC_ASYNC_READ_COMPLETE</ref> event will be raised.</para><para><ref kindref="member" refid="group__group__hal__adc_1gac00f1d333ef4023e3d41dad9dbee5413">cyhal_adc_set_async_mode</ref> can be used to control whether this uses DMA or a SW (CPU-driven) transfer.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>ADC to read from </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">num_scan</parametername>
</parameternamelist>
<parameterdescription>
<para>The number of scans of each channel that should be read </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">result_list</parametername>
</parameternamelist>
<parameterdescription>
<para>The array where results should be. This must be of length num_scan * initialized_channels, where initialized_channels is the number of channels that have been initialized for this ADC (and not later freed) via <ref kindref="member" refid="group__group__hal__adc_1gaba21a0c4d83266951823ea5d9eba39b9">cyhal_adc_channel_init_diff</ref> </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the read async request On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver.<linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="459" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1gac00f1d333ef4023e3d41dad9dbee5413" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref></type>
        <definition>cy_rslt_t cyhal_adc_set_async_mode</definition>
        <argsstring>(cyhal_adc_t *obj, cyhal_async_mode_t mode, uint8_t dma_priority)</argsstring>
        <name>cyhal_adc_set_async_mode</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__general__types_1gab2d2acfb82599df54152be0b170c6ec2">cyhal_async_mode_t</ref></type>
          <declname>mode</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>dma_priority</declname>
        </param>
        <briefdescription>
<para>Set the mechanism that is used to perform ADC asynchronous transfers. </para>        </briefdescription>
        <detaileddescription>
<para>The default is SW. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;The effect of calling this function while an async transfer is pending is undefined.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">mode</parametername>
</parameternamelist>
<parameterdescription>
<para>The transfer mode </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">dma_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority, if DMA is used. Valid values are the same as for <ref kindref="member" refid="group__group__hal__dma_1ga77d62adf012b570ff1a157b43d134318">cyhal_dma_init</ref>. If DMA is not selected, the only valid value is CYHAL_DMA_PRIORITY_DEFAULT, and no guarantees are made about prioritization. </para></parameterdescription>
</parameteritem>
</parameterlist>
<simplesect kind="return"><para>The status of the set mode request On failure, a problem specific error code will be returned. This error could be from the HAL or lower level driver.<linebreak />
 For all other return codes, please refer to device driver documentation available in the BSP landing page </para></simplesect>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="474" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga5ab88800c80f06d91d046a3b6d3144f2" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_adc_register_callback</definition>
        <argsstring>(cyhal_adc_t *obj, cyhal_adc_event_callback_t callback, void *callback_arg)</argsstring>
        <name>cyhal_adc_register_callback</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__adc_1gae4fceb1fa1f96b3212106fda6b113836">cyhal_adc_event_callback_t</ref></type>
          <declname>callback</declname>
        </param>
        <param>
          <type>void *</type>
          <declname>callback_arg</declname>
        </param>
        <briefdescription>
<para>Register an ADC callback handler. </para>        </briefdescription>
        <detaileddescription>
<para>This function will be called when one of the events enabled by <ref kindref="member" refid="group__group__hal__adc_1ga09f4a4783a982751b0f3effc48db1c6b">cyhal_adc_enable_event</ref> occurs.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback</parametername>
</parameternamelist>
<parameterdescription>
<para>The callback handler which will be invoked when the interrupt fires </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">callback_arg</parametername>
</parameternamelist>
<parameterdescription>
<para>Generic argument that will be provided to the callback when called </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="484" />
      </memberdef>
      <memberdef const="no" explicit="no" id="group__group__hal__adc_1ga09f4a4783a982751b0f3effc48db1c6b" inline="no" kind="function" prot="public" static="no" virt="non-virtual">
        <type>void</type>
        <definition>void cyhal_adc_enable_event</definition>
        <argsstring>(cyhal_adc_t *obj, cyhal_adc_event_t event, uint8_t intr_priority, bool enable)</argsstring>
        <name>cyhal_adc_enable_event</name>
        <param>
          <type><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref> *</type>
          <declname>obj</declname>
        </param>
        <param>
          <type><ref kindref="member" refid="group__group__hal__adc_1ga3e21dc2fe98693d72260411459e1fc6c">cyhal_adc_event_t</ref></type>
          <declname>event</declname>
        </param>
        <param>
          <type>uint8_t</type>
          <declname>intr_priority</declname>
        </param>
        <param>
          <type>bool</type>
          <declname>enable</declname>
        </param>
        <briefdescription>
<para>Configure ADC events. </para>        </briefdescription>
        <detaileddescription>
<para>When an enabled event occurs, the function specified by <ref kindref="member" refid="group__group__hal__adc_1ga5ab88800c80f06d91d046a3b6d3144f2">cyhal_adc_register_callback</ref> will be called.</para><para><parameterlist kind="param"><parameteritem>
<parameternamelist>
<parametername direction="in">obj</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC object </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">event</parametername>
</parameternamelist>
<parameterdescription>
<para>The ADC event type </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">intr_priority</parametername>
</parameternamelist>
<parameterdescription>
<para>The priority for NVIC interrupt events </para></parameterdescription>
</parameteritem>
<parameteritem>
<parameternamelist>
<parametername direction="in">enable</parametername>
</parameternamelist>
<parameterdescription>
<para>True to turn on specified events, False to turn off </para></parameterdescription>
</parameteritem>
</parameterlist>
</para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location column="1" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="495" />
      </memberdef>
      </sectiondef>
      <sectiondef kind="define">
      <memberdef id="group__group__hal__adc_1gaf5637d9e3c7fdc08158643043888cdc6" kind="define" prot="public" static="no">
        <name>CYHAL_ADC_BITS</name>
        <initializer>16</initializer>
        <briefdescription>
<para>Number of bits populated with meaningful data by each ADC sample. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="115" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="115" />
      </memberdef>
      <memberdef id="group__group__hal__adc_1ga51d4fd58442f9c1e0804e3cf0b20c46e" kind="define" prot="public" static="no">
        <name>CYHAL_ADC_MAX_VALUE</name>
        <initializer>((1 &lt;&lt; <ref kindref="member" refid="group__group__hal__adc_1gaf5637d9e3c7fdc08158643043888cdc6">CYHAL_ADC_BITS</ref>) - 1)</initializer>
        <briefdescription>
<para>Maximum value that the ADC can return. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="117" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="117" />
      </memberdef>
      <memberdef id="group__group__hal__adc_1ga989ece649f9a1d7df78b73a0b75abf24" kind="define" prot="public" static="no">
        <name>CYHAL_ADC_AVG_MODE_AVERAGE</name>
        <initializer>(1u &lt;&lt; 0)</initializer>
        <briefdescription>
<para>Perform standard averaging. </para>        </briefdescription>
        <detaileddescription>
<para>Divide the accumulated value by the number of samples. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;This is not supported in combination with &lt;a href="group__group__hal__adc.html#group__group__hal__adc_1gaffbef3cc844fa6ff749e8230c6ef6d54"&gt;CYHAL_ADC_AVG_MODE_ACCUMULATE&lt;/a&gt; &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="144" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="144" />
      </memberdef>
      <memberdef id="group__group__hal__adc_1gaffbef3cc844fa6ff749e8230c6ef6d54" kind="define" prot="public" static="no">
        <name>CYHAL_ADC_AVG_MODE_ACCUMULATE</name>
        <initializer>(1u &lt;&lt; 1)</initializer>
        <briefdescription>
<para>Accumulate samples as in <ref kindref="member" refid="group__group__hal__adc_1ga989ece649f9a1d7df78b73a0b75abf24">CYHAL_ADC_AVG_MODE_AVERAGE</ref>, but do not divide by the number of samples. </para>        </briefdescription>
        <detaileddescription>
        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="146" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="146" />
      </memberdef>
      <memberdef id="group__group__hal__adc_1gaf5c909ab5cc7409a896abceda7da5773" kind="define" prot="public" static="no">
        <name>CYHAL_ADC_AVG_MODE_MAX_SHIFT</name>
        <initializer>(1u)</initializer>
        <briefdescription>
<para>Average mode flag position indices shifted by greater than this are implementation specific. </para>        </briefdescription>
        <detaileddescription>
<para>The value of this macro is subject to change between HAL versions. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="149" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="149" />
      </memberdef>
      <memberdef id="group__group__hal__adc_1ga00175bb8e85fface6d74488febb0cf27" kind="define" prot="public" static="no">
        <name>CYHAL_ADC_VNEG</name>
        <initializer><ref kindref="member" refid="group__group__hal__gpio_1ga25a61e0d5a27c77dca1c7709fba9c400">CYHAL_NC_PIN_VALUE</ref></initializer>
        <briefdescription>
<para>Selects the default connection for the inverting input to achieve a single-ended channel. </para>        </briefdescription>
        <detaileddescription>
<para>This connection is controlled by the vneg member of <ref kindref="compound" refid="structcyhal__adc__config__t">cyhal_adc_config_t</ref>. </para>        </detaileddescription>
        <inbodydescription>
        </inbodydescription>
        <location bodyend="-1" bodyfile="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" bodystart="154" column="9" file="output/libs/COMPONENT_DEPRECATED/psoc6hal/include/cyhal_adc.h" line="154" />
      </memberdef>
      </sectiondef>
    <briefdescription>
<para>High level interface for interacting with the analog to digital converter (ADC). </para>    </briefdescription>
    <detaileddescription>

<para><heading level="1">Features</heading></para>
<para>Each ADC instance supports one or more selectable channels, each of which can perform conversions on a different pin. See the device datasheet for details about which pins support ADC conversion.</para><para>Both single-ended and differential channels are supported. The values returned by the read API are relative to the ADC's voltage range, which is device specific. See the BSP documentation for details.</para>

<para><heading level="1">Quickstart</heading></para>
<para>Call <ref kindref="member" refid="group__group__hal__adc_1ga7618b26a0677cb3f8cd477e3731da510">cyhal_adc_init</ref> to initialize an ADC instance by providing the ADC object (<bold>obj</bold>), input pin (<bold>pin</bold>) and clock (<bold>clk</bold>).<linebreak />
 The input pin argument is just to signify which ADC instance to initialize. It does not actually reserve the pin or create an ADC channel for it. The clock parameter can be left NULL to use an available clock resource with a default frequency.<linebreak />
 Use <ref kindref="member" refid="group__group__hal__adc_1gaba21a0c4d83266951823ea5d9eba39b9">cyhal_adc_channel_init_diff</ref> to initialize one or more channels associated with that instance.<linebreak />
 Use <ref kindref="member" refid="group__group__hal__adc_1ga7207c3d089c48255e382cfe159a04ed0">cyhal_adc_read</ref> for reading the results.<linebreak />
 See <ref kindref="member" refid="group__group__hal__adc_1subsection_adc_snippet_1">Snippet 1: Simple ADC initialization and reading conversion result</ref>.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;a href="group__group__hal__adc.html#group__group__hal__adc_1ga2baef8269f13b3c7da46cdabcef650a0"&gt;cyhal_adc_read_u16&lt;/a&gt; always returns a 16 bit value in the range 0x0000-0xFFFF. If the underlying hardware does not support 16 bit resolution the value is scaled linearly to cover the full 16 bits.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><heading level="1">Code snippets</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Error checking is omitted for clarity &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>
<para><bold>Snippet 1: Simple ADC initialization and reading conversion result</bold></para>
<para>The following snippet initializes an ADC and one channel. One ADC conversion result is returned corresponding to the input at the specified pin. <programlisting filename="adc.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref><sp />adc_obj;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref><sp />adc_chan_0_obj;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />ADC<sp />conversion<sp />result.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />int32_t<sp />adc_out;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />ADC.<sp />The<sp />ADC<sp />block<sp />which<sp />can<sp />connect<sp />to<sp />pin<sp />10[0]<sp />is<sp />selected<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__adc_1ga7618b26a0677cb3f8cd477e3731da510">cyhal_adc_init</ref>(&amp;adc_obj,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a3d6f6bf971075551e669f9044ddb30e3">P10_0</ref>,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />ADC<sp />channel,<sp />allocate<sp />channel<sp />number<sp />0<sp />to<sp />pin<sp />10[0]<sp />as<sp />this<sp />is<sp />the<sp />first<sp />channel<sp />initialized<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__adc__channel__config__t">cyhal_adc_channel_config_t</ref><sp />channel_config<sp />=<sp />{<sp />.<ref kindref="member" refid="structcyhal__adc__channel__config__t_1ac2dae19e04515fbcb59cd43ce2e55a72">enable_averaging</ref><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,<sp />.min_acquisition_ns<sp />=<sp />220,<sp />.enabled<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal"><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__adc_1gaba21a0c4d83266951823ea5d9eba39b9">cyhal_adc_channel_init_diff</ref>(&amp;adc_chan_0_obj,<sp />&amp;adc_obj,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a3d6f6bf971075551e669f9044ddb30e3">P10_0</ref>,<sp /><ref kindref="member" refid="group__group__hal__adc_1ga00175bb8e85fface6d74488febb0cf27">CYHAL_ADC_VNEG</ref>,<sp />&amp;channel_config);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />the<sp />ADC<sp />conversion<sp />result<sp />for<sp />corresponding<sp />ADC<sp />channel.<sp />Repeat<sp />as<sp />necessary.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />adc_out<sp />=<sp /><ref kindref="member" refid="group__group__hal__adc_1ga7207c3d089c48255e382cfe159a04ed0">cyhal_adc_read</ref>(&amp;adc_chan_0_obj);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Release<sp />ADC<sp />and<sp />channel<sp />objects<sp />when<sp />no<sp />longer<sp />needed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1ga55d144073f10cf6b6a1edcf6b9f59c78">cyhal_adc_channel_free</ref>(&amp;adc_chan_0_obj);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1gadae8361e3e3e3d0ff96767e1e8e1d913">cyhal_adc_free</ref>(&amp;adc_obj);</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 2: Multi-channel ADC initialization and reading conversion result</bold></para>
<para>The following snippet initializes an ADC with one single-ended channel and one differential channel <programlisting filename="adc.c"><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref><sp />adc_obj;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref><sp />adc_chan_0_obj;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref><sp />adc_chan_1_obj;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />32-bit<sp />ADC<sp />conversion<sp />result<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />int32_t<sp />adc_out_0;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />int32_t<sp />adc_out_1;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Use<sp />the<sp />same<sp />configuration<sp />for<sp />both<sp />channels<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__adc__channel__config__t">cyhal_adc_channel_config_t</ref><sp />channel_config<sp />=<sp />{<sp />.<ref kindref="member" refid="structcyhal__adc__channel__config__t_1ac2dae19e04515fbcb59cd43ce2e55a72">enable_averaging</ref><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">,<sp />.min_acquisition_ns<sp />=<sp />220,<sp />.enabled<sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal"><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />ADC.<sp />The<sp />ADC<sp />block<sp />which<sp />can<sp />connect<sp />to<sp />pin<sp />10[0]<sp />is<sp />selected<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__adc_1ga7618b26a0677cb3f8cd477e3731da510">cyhal_adc_init</ref>(&amp;adc_obj,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a3d6f6bf971075551e669f9044ddb30e3">P10_0</ref>,<sp />NULL);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />a<sp />channel<sp />to<sp />scan<sp />P10_0<sp />with<sp />the<sp />default<sp />vminus<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__adc_1gaba21a0c4d83266951823ea5d9eba39b9">cyhal_adc_channel_init_diff</ref>(&amp;adc_chan_0_obj,<sp />&amp;adc_obj,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a3d6f6bf971075551e669f9044ddb30e3">P10_0</ref>,<sp /><ref kindref="member" refid="group__group__hal__adc_1ga00175bb8e85fface6d74488febb0cf27">CYHAL_ADC_VNEG</ref>,<sp />&amp;channel_config);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />a<sp />differential<sp />channel<sp />for<sp />the<sp />pair<sp />of<sp />P10_2<sp />and<sp />P10_3<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__adc_1gaba21a0c4d83266951823ea5d9eba39b9">cyhal_adc_channel_init_diff</ref>(&amp;adc_chan_1_obj,<sp />&amp;adc_obj,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51aec9f8c6c169e3ffce4866e4a1677d873">P10_2</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__pin__package__psoc6__01__104__m__csp__ble_1gga707195ce0627016bf371643bdd9caa51a687b4a01d80cb5284be1bc42362f79d6">P10_3</ref>,<sp />&amp;channel_config);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />the<sp />ADC<sp />conversion<sp />results<sp />for<sp />both<sp />channels.<sp />Repeat<sp />as<sp />necessary.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />adc_out_0<sp />=<sp /><ref kindref="member" refid="group__group__hal__adc_1ga7207c3d089c48255e382cfe159a04ed0">cyhal_adc_read</ref>(&amp;adc_chan_0_obj);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />adc_out_1<sp />=<sp /><ref kindref="member" refid="group__group__hal__adc_1ga7207c3d089c48255e382cfe159a04ed0">cyhal_adc_read</ref>(&amp;adc_chan_1_obj);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Release<sp />ADC<sp />and<sp />channel<sp />objects<sp />when<sp />no<sp />longer<sp />needed<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1ga55d144073f10cf6b6a1edcf6b9f59c78">cyhal_adc_channel_free</ref>(&amp;adc_chan_0_obj);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1ga55d144073f10cf6b6a1edcf6b9f59c78">cyhal_adc_channel_free</ref>(&amp;adc_chan_1_obj);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1gadae8361e3e3e3d0ff96767e1e8e1d913">cyhal_adc_free</ref>(&amp;adc_obj);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
</programlisting> </para>

<para><bold>Snippet 3: Asynchronously read multiple channels</bold></para>
<para>The following snippet illustrates how to asynchronously read multiple scans of multiple channels. <programlisting filename="adc.c"><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />NUM_CHANNELS<sp />(2)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor">#define<sp />NUM_SCAN<sp /><sp /><sp /><sp /><sp />(3)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />adc_event_handler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />arg,<sp /><ref kindref="member" refid="group__group__hal__adc_1ga3e21dc2fe98693d72260411459e1fc6c">cyhal_adc_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Note:<sp />arg<sp />is<sp />configured<sp />below<sp />to<sp />be<sp />a<sp />pointer<sp />to<sp />the<sp />destination<sp />array<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0u<sp />!=<sp />(event<sp />&amp;<sp /><ref kindref="member" refid="group__group__hal__adc_1gga3e21dc2fe98693d72260411459e1fc6ca4a42dd67489a8b89bb8b1fefdac6c86c">CYHAL_ADC_ASYNC_READ_COMPLETE</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />int32_t*<sp />result_arr<sp />=<sp />(int32_t*)arg;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />scan<sp />=<sp />0;<sp />scan<sp />&lt;<sp />NUM_SCAN;<sp />++scan)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />channel<sp />=<sp />0;<sp />channel<sp />&lt;<sp />NUM_CHANNELS;<sp />++channel)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />application-specific<sp />processing<sp />of<sp />the<sp />ADC<sp />result<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />process_adc_result(channel,<sp />result_arr[(scan<sp />*<sp />NUM_CHANNELS)<sp />+<sp />channel]);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_cyhal_adc_read_async(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref><sp />adc_obj;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />ADC<sp />and<sp />its<sp />channels<sp />as<sp />shown<sp />in<sp />Snippet<sp />2<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />int32_t<sp />result_arr[NUM_CHANNELS<sp />*<sp />NUM_SCAN];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />a<sp />callback<sp />and<sp />set<sp />the<sp />callback<sp />argument<sp />to<sp />be<sp />a<sp />pointer<sp />to<sp />the<sp />result<sp />array</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />so<sp />that<sp />we<sp />can<sp />easily<sp />reference<sp />it<sp />in<sp />the<sp />event<sp />handler.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1ga5ab88800c80f06d91d046a3b6d3144f2">cyhal_adc_register_callback</ref>(&amp;adc_obj,<sp />&amp;adc_event_handler,<sp />result_arr);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Subscribe<sp />to<sp />the<sp />async<sp />read<sp />complete<sp />event<sp />so<sp />that<sp />we<sp />we<sp />can<sp />process<sp />the<sp />results<sp />when<sp />they<sp />are<sp />available<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1ga09f4a4783a982751b0f3effc48db1c6b">cyhal_adc_enable_event</ref>(&amp;adc_obj,<sp /><ref kindref="member" refid="group__group__hal__adc_1gga3e21dc2fe98693d72260411459e1fc6ca4a42dd67489a8b89bb8b1fefdac6c86c">CYHAL_ADC_ASYNC_READ_COMPLETE</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gad822a466fc63847114add720ef84c83a">CYHAL_ISR_PRIORITY_DEFAULT</ref>,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initiate<sp />an<sp />asynchronous<sp />read<sp />operation.<sp />The<sp />event<sp />handler<sp />will<sp />be<sp />called<sp />when<sp />it<sp />is<sp />complete.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1ga7386fc156403ea08380c4410665b4ae2">cyhal_adc_read_async</ref>(&amp;adc_obj,<sp />NUM_SCAN,<sp />result_arr);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting> </para>

<para><bold>Snippet 4: Continuous scanning</bold></para>
<para>This snippet shows how to run the ADC in continuous mode and process results as each scan completes. <programlisting filename="adc.c"><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__adc__channel__t">cyhal_adc_channel_t</ref><sp />adc_channels[NUM_CHANNELS];</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />adc_continuous_event_handler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">*<sp />arg,<sp /><ref kindref="member" refid="group__group__hal__adc_1ga3e21dc2fe98693d72260411459e1fc6c">cyhal_adc_event_t</ref><sp />event)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(arg);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(event);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Note:<sp />arg<sp />is<sp />configured<sp />below<sp />to<sp />be<sp />a<sp />pointer<sp />to<sp />the<sp />adc<sp />object<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(0u<sp />!=<sp />(event<sp />&amp;<sp /><ref kindref="member" refid="group__group__hal__adc_1gga3e21dc2fe98693d72260411459e1fc6ca72cdd442365c9b501eb0144ef31beb83">CYHAL_ADC_EOS</ref>))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">for</highlight><highlight class="normal">(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />i<sp />=<sp />0;<sp />i<sp />&lt;<sp />NUM_CHANNELS;<sp />++i)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Perform<sp />application-specific<sp />processing<sp />of<sp />the<sp />ADC<sp />result<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />process_adc_result(i,<sp /><ref kindref="member" refid="group__group__hal__adc_1ga7207c3d089c48255e382cfe159a04ed0">cyhal_adc_read</ref>(&amp;adc_channels[i]));</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_cyhal_adc_continuous_read(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__adc__t">cyhal_adc_t</ref><sp />adc_obj;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Initialize<sp />the<sp />each<sp />member<sp />of<sp />the<sp />adc_channels<sp />array<sp />as<sp />shown<sp />in<sp />Snippet<sp />2<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcyhal__adc__config__t">cyhal_adc_config_t</ref><sp />config<sp />=<sp />{<sp /></highlight><highlight class="comment">/*<sp />Other<sp />configuration<sp />options<sp />are<sp />omitted<sp />here<sp />for<sp />clarity<sp />*/</highlight><highlight class="normal"><sp />.<ref kindref="member" refid="structcyhal__adc__config__t_1a942daebdd7db9f8f38ea3f2d33503b68">continuous_scanning</ref><sp />=<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal"><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Register<sp />a<sp />callback<sp />and<sp />set<sp />the<sp />callback<sp />argument<sp />to<sp />be<sp />a<sp />pointer<sp />to<sp />the<sp />adc<sp />object</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />so<sp />that<sp />we<sp />can<sp />easily<sp />reference<sp />it<sp />in<sp />the<sp />event<sp />handler.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1ga5ab88800c80f06d91d046a3b6d3144f2">cyhal_adc_register_callback</ref>(&amp;adc_obj,<sp />&amp;adc_continuous_event_handler,<sp />&amp;adc_obj);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Subscribe<sp />to<sp />the<sp />end<sp />of<sp />scan<sp />event<sp />so<sp />that<sp />we<sp />we<sp />can<sp />process<sp />the<sp />results<sp />as<sp />each<sp />scan<sp />completes*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1ga09f4a4783a982751b0f3effc48db1c6b">cyhal_adc_enable_event</ref>(&amp;adc_obj,<sp /><ref kindref="member" refid="group__group__hal__adc_1gga3e21dc2fe98693d72260411459e1fc6ca72cdd442365c9b501eb0144ef31beb83">CYHAL_ADC_EOS</ref>,<sp /><ref kindref="member" refid="group__group__hal__impl__hw__types_1gad822a466fc63847114add720ef84c83a">CYHAL_ISR_PRIORITY_DEFAULT</ref>,<sp /></highlight><highlight class="keyword">true</highlight><highlight class="normal">);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Call<sp />the<sp />ADC<sp />configure<sp />function<sp />to<sp />begin<sp />continuous<sp />scanning<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__adc_1gae1abce4e4cfe015eb4cd4dd055ca3065">cyhal_adc_configure</ref>(&amp;adc_obj,<sp />&amp;config);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

    </detaileddescription>
  </compounddef>
</doxygen>